# TC20_TimeStamp2.rb
# A timestamp script, using the TurboCAD API and IronRuby scripting.
# Modified by Kevan Chapman from a script posted on the TurboCAD SDK forums.
# Places the drawing name, time and date, and an optional string of text
# into the drawing. 
# User specifies text height and location in the dialog box.
# Geaendert von mike kuhn am 15.04.2014
# druckt vollen Dateipfad und Datum auf europaeische Schreibweise
# load the necessary libraries
require "System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089"
require "System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a"

include System::Windows::Forms
include System::Drawing
include System



def add_filepath
  # label and text box for text height
	tshlabel = Label.new
	tshlabel.Width = 100
	tshlabel.Text = 'Texthoehe:'
	tshlabel.Location = System::Drawing::Point.new(5,15)	
	txtHeight = TextBox.new
  txtHeight.Width = 100
  txtHeight.Text = "5"
  txtHeight.Location = System::Drawing::Point.new(150,15)
  
  # label and text boxes for location of timestamp
	tsXlabel = Label.new
	tsXlabel.Width = 100
	tsXlabel.Text = 'X - Coordinate:'
	tsXlabel.Location = System::Drawing::Point.new(5,45)	
	tsX = TextBox.new
  tsX.Width = 100
  tsX.Text = "0"
  tsX.Location = System::Drawing::Point.new(150,45)

	tsylabel = Label.new
	tsylabel.Width = 100
	tsylabel.Text = 'Y - Coordinate:'
	tsylabel.Location = System::Drawing::Point.new(5,75)	
	tsY = TextBox.new
  tsY.Width = 100
  tsY.Text = "0"
  tsY.Location = System::Drawing::Point.new(150,75)

	tsOptlabel = Label.new
	tsOptlabel.Width = 125
	tsOptlabel.Text = 'Zusatztext optional:'
	tsOptlabel.Location = System::Drawing::Point.new(5,105)	
	txtOpt = TextBox.new
  txtOpt.Width = 150
  txtOpt.Location = System::Drawing::Point.new(150,105)

	draw = Button.new
	draw.Text = 'Dateipfad schreiben'
	draw.Width = 120
	draw.Location = System::Drawing::Point.new(50,135)
  # Handle button click
  draw.click do |sender, args|
    # obtain values from fields in input dialog and convert to appropriate types
    ht = Convert.ToDouble(txtHeight.Text)
    x = Convert.ToDouble(tsX.Text)
    y = Convert.ToDouble(tsY.Text)
    myText = txtOpt.Text
    
    # get current time and format it to a string
    time = Time.new
    tts = time.strftime("%d.%m.%Y %H:%M:%S")
  
    # obtain variables for the TCAPI pieces needed: application, drawing, graphics, view  
    tcApp = TCApplication
    tcDrw = tcApp.ActiveDrawing
    tcView = tcDrw.ActiveView
    tcGrx = tcDrw.Graphics
    
    # Name property retrieves the full path and name of the drawing.
    # Parse out the path portion using Ruby's split function to split on backslashes
    txtName = tcDrw.Name
   
       
    # now draw the name and timestamp, plus the optional text if any,
    # starting at the specified coordinate
    tcGrx.AddText(txtName, x, y, 0, ht, 0, 1, 1)
    tcGrx.AddText(tts, x, y-ht, 0, ht, 0, 1, 1)
    if (myText != nil) and (myText.Length > 0) then
      tcGrx.AddText(myText, x, y-2*ht, 0, ht, 0, 1, 1)
    end
    tcView.ZoomToExtents
    tcView = nil
    tcGrx = nil
    tcDrw = nil
    tcApp = nil
    draw.Parent.Close
  end
  
  #Run
	form = Form.new
	form.Text = 'Dateipfad und Zeit schreiben'
	form.Height = 200
	form.Width = 400
	form.Controls.Add tshlabel
  form.Controls.Add txtHeight 
	form.Controls.Add tsXlabel
  form.Controls.Add tsX 
	form.Controls.Add tsylabel
  form.Controls.Add tsY 
	form.Controls.Add tsOptlabel
  form.Controls.Add txtOpt 
	form.Controls.Add draw 
	form.ShowDialog()
end

UI.menu("Plugins").add_item("TC Add Timestamp2"){add_filepath}

